
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Codeforces Round #271 (Div. 2)D(递推，前缀和) / 憋错料</title>

    <meta name="description" content="Codeforces Round #271 (Div. 2)D(递推，前缀和) 很简单的递推题.d[n]=d[n-1]+d[n-k] 注意每次输入a和b时,如果每次都累加,就做了很多重复性工作,会超时. 所以用预处理前缀和来解决重复累加问题. 最后一个细节坑了我多次: printf(&quot;%I64d\n&quot;,(s[b]-s[a-1]+mod)%mod); 这句话中加mod万万不能少,因为理论上s[b]-s[a-1]肯定大于0,但是由于两个都是模1000000007以后的结果,那么就不一定了,当s[b]-s[a-1]&lt;0时结果是负的,不是题意中应该输出的结 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Codeforces Round #271 (Div. 2)D(递推，前缀和)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>很简单的递推题。d[n]=d[n-1]+d[n-k]</p>
<p>注意每次输入a和b时，如果每次都累加，就做了很多重复性工作，会超时。</p>
<p>所以用预处理前缀和来解决重复累加问题。</p>
<p>最后一个细节坑了我多次：</p>
<p>printf("%I64d\n",(s[b]-s[a-1]+mod)%mod);</p>
<p>这句话中加mod万万不能少，因为理论上s[b]-s[a-1]肯定大于0，但是由于两个都是模1000000007以后的结果，那么就不一定了，当s[b]-s[a-1]&lt;0时结果是负的，不是题意中应该输出的结果，所以一定要加mod。</p>
<pre>#include&lt;iostream&gt;
#include&lt;cstdio&gt;
#include&lt;cstdlib&gt;
#include&lt;cstring&gt;
#include&lt;cmath&gt;
#include&lt;map&gt;
#include&lt;set&gt;
#include&lt;vector&gt;
#include&lt;algorithm&gt;
#include&lt;stack&gt;
#include&lt;queue&gt;
#include&lt;cctype&gt;
#include&lt;sstream&gt;
using namespace std;
#define INF 1000000000
#define eps 1e-8
#define pii pair&lt;int,int&gt;
#define LL long long int
#define mod 1000000007
LL t,k,a,b,d[100010],s[100010];
int main()
{
    //freopen("in8.txt","r",stdin);
    //freopen("out.txt","w",stdout);
    scanf("%I64d%I64d",&amp;t,&amp;k);
    for(int i=1;i&lt;k;i++) d[i]=1;
    d[k]=2;
    for(int i=k+1;i&lt;=100000;i++)
    {
        d[i]=(d[i-1]+d[i-k])%mod;
    }
    s[0]=0;
    s[1]=d[1];
    for(int i=2;i&lt;=100000;i++)
    {
        s[i]=(s[i-1]+d[i])%mod;
    }
    for(int i=0;i&lt;t;i++)
    {
        scanf("%I64d%I64d",&amp;a,&amp;b);
        printf("%I64d\n",(s[b]-s[a-1]+mod)%mod);
    }
    //fclose(stdin);
    //fclose(stdout);
    return 0;
}</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-18 07:34:45 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/div/" title="div">div</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Codeforces Round #271 (Div. 2)D(递推，前缀和)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pzLLV0.html" rel="bookmark">Codeforces Round &num;245 &lpar;Div&period; 1&rpar;B   递推DP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1000 * 1000的图,交点就一个,而且如何相交于一点 画一画就会发现就两种情况,所以首先想到的是可以暴力枚举交点,然后由交点往前推,相交过后两个人继续朝自己目的地前进,所以可以先 暴力枚举  并 递推出每一个点 到这个图的 四个顶点的 最大值,然后根据相交的两种情况取最优的一个即可 int mp[1000 + 55][1000 + 55]; int dp1[1000 + 55][1000 + 55],dp2[1000 + 55][1000 + 55],dp3[1000 + 55][1000			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6elEG4.html" rel="bookmark">Codeforces Round &num;271 &lpar;Div&period; 2&rpar; D&period; Flowers &lpar;递推&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目链接:http://codeforces.com/problemset/problem/474/D 用RW组成字符串,要求w的个数要k个连续出现,R任意,问字符串长度为[a, b]时,字符串的种类有多少. 递推,dp[i]表示长度为i的种类有多少.当i &lt; k的时候 dp[i] = 1 , 当i == k的时候 dp[i] = 2 ,  否则 dp[i] = dp[i - 1] + dp[i - k] . 1 #include &lt;bits/stdc++.h&gt; 2 using name			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49GPAv0.html" rel="bookmark">&lpar;补题解）Codeforces Round &num;271 &lpar;Div&period; 2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言:最近被线段树+简单递推DP虐的体无完肤!真是弱! A:简单题,照着模拟就可以,题目还特意说不用处理边界 B:二分查找即可,用lower_lound()函数很好用 1 #include&lt;string.h&gt; 2 #include&lt;math.h&gt; 3 #include&lt;algorithm&gt; 4 #include&lt;stdio.h&gt; 5 #include&lt;math.h&gt; 6 #include&lt;string&gt; 7 #include&lt;i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QjZwLM.html" rel="bookmark">Codeforces Round &num;271 &lpar;Div&period; 2&rpar; D&period; Flowers （递推 预处理）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				We saw the little game Marmot made for Mole's lunch. Now it's Marmot's dinner time and, as we all know, Marmot eats flowers. At every dinner he eats some red and white flowers. Therefore a dinner can be represented as a sequence of several flowers, s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/x0d8Vn0.html" rel="bookmark">Codeforces Round &num;271 &lpar;Div&period; 2&rpar; F&period;Ant colony&lpar;线段树 &plus; 统计区间内某数的个数&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				F. Ant colony Mole is hungry again. He found one ant colony, consisting of n ants, ordered in a row. Each ant i (1 ≤ i ≤ n) has a strength si. In order to make his dinner more interesting, Mole organizes a version of «Hunger Games» for the ants. He c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWwoDBM.html" rel="bookmark">Codeforces Round &num;271 &lpar;Div&period; 2&rpar; D&period;Flowers DP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				D. Flowers We saw the little game Marmot made for Mole's lunch. Now it's Marmot's dinner time and, as we all know, Marmot eats flowers. At every dinner he eats some red and white flowers. Therefore a dinner can be represented as a sequence of several			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M61VQZ4.html" rel="bookmark">Codeforces Round &num;271 &lpar;Div&period; 2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				It is lunch time for Mole. His friend, Marmot, prepared him a nice game for lunch. Marmot brought Mole n ordered piles of worms such that i-th pile contains ai worms. He labeled all these worms with consecutive integers: worms in first pile are label			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pzzYo0.html" rel="bookmark">Codeforces Round &num;271 &lpar;Div&period; 2&rpar; A&period; Keyboard</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Our good friend Mole is trying to code a big message. He is typing on an unusual keyboard with characters arranged in following way: qwertyuiop asdfghjkl; zxcvbnm,./ Unfortunately Mole is blind, so sometimes it is problem for him to put his hands acc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6paBX3.html" rel="bookmark">递推 Codeforces Round &num;186 &lpar;Div&period; 2&rpar; B&period; Ilya and Queries</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目传送门 1 /* 2 递推:用cnt记录前缀值,查询区间时,两个区间相减 3 */ 4 #include &lt;cstdio&gt; 5 #include &lt;algorithm&gt; 6 #include &lt;cmath&gt; 7 #include &lt;cstring&gt; 8 using namespace std; 9 10 const int MAXN = 1e5 + 10; 11 const int INF = 0x3f3f3f3f; 12 char s[MAXN]; 1			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMywn3O.html" rel="bookmark" class="title">使用OAuth打造webapi认证服务供自己的客户端使用</a>
					<div>
						一.什么是OAuth OAuth是一个关于授权(Authorization)的开放网络标准,目前的版本是2.0版.注意是Authorization(授权),而不是Authentication(认证). ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMy7Am3.html" rel="bookmark" class="title">windows下mysql数据库定时备份。</a>
					<div>
						注意:看本教程先必须会windows自带的&quot;任务计划程序&quot;. 首先创建一个bat后缀的文件我的是timerExecutePhp.bat文件 timerExecutePhp.bat  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGGzvAM.html" rel="bookmark" class="title">CC2540开发板学习笔记（四）&amp;mdash&semi;&amp;mdash&semi;定时器</a>
					<div>
						一.实验内容 分别使用定时器T1和T3使得LED周期性闪烁 二.实验过程 1.定时器T1(查询IRCON来控制) (1)需要调配的寄存器 T1CTL(0XE4) Timer1控制寄存器   BIT3, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xQqVD3.html" rel="bookmark" class="title">持续集成之</a>
					<div>
						安装jenkins yum -y install java-1.8.0cd /etc/yum.repos.d/wget http://pkg.jenkins.io/redhat/jenkins.rep ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vv5m93.html" rel="bookmark" class="title">合并表格</a>
					<div>
						&lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/html; char ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41gboJ0.html" rel="bookmark" class="title">JVM的GC机制及JVM的调优方法</a>
					<div>
						内存管理和垃圾回收是JVM非常关键的点,对Java性能的剖析而言,了解内存管理和垃圾回收的基本策略非常重要. 1.在程序运行过程当中,会创建大量的对象,这些对象,大部分是短周期的对象,小部分是长周期的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02mxlzM.html" rel="bookmark" class="title">NFS  服务配置篇</a>
					<div>
						安装.配置NFS服务 1.NFS简介 NFS(network file system) NFS是一个主机A通过网络,允许其他主机B可以来共享主机A的一个目录文件的一个文件系统 2.需要安装两个包nfs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lG1WLM.html" rel="bookmark" class="title">基于SVM&plus;HOG的花生品种识别</a>
					<div>
						早在大二时,导师做过一个花生品种识别的程序,但当时用于品种识别的特征是自定义特征:而我的当初的本科毕业设计则是基于SVM + HOG的人脸识别:在后来的工作学习中,又用到了HOG特征,想着是不是之前的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wy521M.html" rel="bookmark" class="title">Unity与IOS交互</a>
					<div>
						转自:http://www.cnblogs.com/alongu3d/p/3674174.html 环境:Mac os 10.9.2  Unity 4.2.1f4   Xcode 5.0.2 Unit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M62aaGM.html" rel="bookmark" class="title">Eclipse导入项目：No projects are found to import</a>
					<div>
						如果发现导入工程(impot)的时候,出现”No projects are found to import” 的提示, 首先查看项目目录中是否有隐藏文件.project,还有目录结构也还要有一个隐藏文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXQmAG0.html" rel="bookmark" class="title">HDU 4638-Group（线段树&plus;离线处理）</a>
					<div>
						题意: 给n个编号,m个查询每个查询l,r,求下标区间[l,r]中能分成标号连续的组数(一组内的标号是连续的) 分析: 我们认为初始,每个标号为一个组(线段树维护区间组数),从左向右扫序列,当前标号, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RDDL94.html" rel="bookmark" class="title">快速排序算法（Java）</a>
					<div>
						快速排序算法的基本思想是:通过一趟排序将待排记录分割成独立的两部分,其中一部分记录的关键字均比另外一部分记录的关键字小,则可分别对这两部分记录继续进行排序,以达到整个序列有序. class Parti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWANB4.html" rel="bookmark" class="title">降低mysql事务隔离级别</a>
					<div>
						测试代码的时候实验了下降低事物隔离级别: Connection conn = null; try { conn = DBUtils.getConnection(); conn.setAutoCommi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEvg9X0.html" rel="bookmark" class="title">URL学习笔记</a>
					<div>
						不多说,先上代码,代码的注释写的已经挺详细的了 1 //URL:统一资源定位符,一个URL的对象,对应着互联网上的一个资源. 2 //我们可以通过URL的对象调用其相应的方法,将此资源读取(即所谓的“ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyWZWm3.html" rel="bookmark" class="title">rtmp的URL里面mp3&colon;和mp4&colon;是啥意思</a>
					<div>
						rtmp请求一般格式是rtmp://域名/app/文件   比如rtmp://fantefei.blog.51cto.com/fantefei/3.mp4这样就可以播放了,但是rtmp://fante ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a1JWg0.html" rel="bookmark" class="title">栈实现一个小迷宫</a>
					<div>
						概括:实现迷宫的算法主要在于查找和回溯.从入口开始之后我们所查找的每一个位置都要去判断它的另外三个方向(不包括刚刚走过的路径)的路径能不能通,如果能通则到下个位置,并将上个位置进行标注.在将此位置作为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEWWpg3.html" rel="bookmark" class="title">android 围绕中心旋转动画</a>
					<div>
						本文主要介绍Android中如何使用rotate实现图片不停旋转的效果.Android 平台提供了两类动画,一类是 Tween 动画,即通过对场景里的对象不断做图像变换(平移.缩放.旋转)产生动画效果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NnXEJ4.html" rel="bookmark" class="title">SVN服务器搭建（1）</a>
					<div>
						转自:http://www.cnblogs.com/xiaobaihome/archive/2012/03/20/2407610.html SVN服务器搭建和使用(一) Subversion是优秀的版 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wBWal0.html" rel="bookmark" class="title">一次完整的HTTP事务是怎样一个过程？&lpar;转&rpar;</a>
					<div>
						(转自http://www.linux178.com/web/httprequest.html)写的太好了,转一个. 关于HTTP协议可以参考以下: HTTP协议漫谈 http://kb.cnblog ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVvqDjM.html" rel="bookmark" class="title">串口通讯服务类</a>
					<div>
						通讯事件类 public class ComEvent { /// &lt;summary&gt; /// 数据接收事件 /// &lt;/summary&gt; /// &lt;param name ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
